Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/SlaveCommListener.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/SlaveCommListener.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/SlaveCommListener.cs	(revision 6033)
@@ -56,5 +56,5 @@
 
     public void Close() {
-      if (pipeFactory.State != CommunicationState.Closed) {
+      if (pipeFactory.State != CommunicationState.Closed && pipeFactory.State != CommunicationState.Closing) {
         pipeProxy.Unsubscribe();
         pipeFactory.Close();
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj	(revision 6033)
@@ -71,7 +71,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
-      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Collections-3.3.dll</HintPath>
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLabClientsHiveSlaveViewsPlugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLabClientsHiveSlaveViewsPlugin.cs.frame	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLabClientsHiveSlaveViewsPlugin.cs.frame	(revision 6033)
@@ -29,8 +29,17 @@
   [Plugin("HeuristicLab.Clients.Hive.Slave.Views", "3.4.0.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive.Slave.Views-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Clients.Hive.SlaveCore", "3.4")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Clients.Hive.SlaveCore", "3.4")]
   public class HeuristicLabClientsHiveSlaveViewsPlugin : PluginBase {
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLabClientsHiveSlavePlugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLabClientsHiveSlavePlugin.cs.frame	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLabClientsHiveSlavePlugin.cs.frame	(revision 6033)
@@ -8,6 +8,10 @@
   [Plugin("HeuristicLab.Clients.Hive.SlaveCore", "3.4.0.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive.SlaveCore-3.4.dll", PluginFileType.Assembly)]
+  
+  [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Clients.Hive", "3.4")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Hive", "3.4")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabClientsHiveSlavePlugin : PluginBase {
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/StatusCommons.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/StatusCommons.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/StatusCommons.cs	(revision 6033)
@@ -48,4 +48,8 @@
     [DataMember]
     public List<JobStatus> Jobs { get; set; }
+
+    public override string ToString() {
+      return string.Format("Status: {0}, Fetched/Done/Aborted: {1},{2},{3}", Status, JobsFetched, JobsDone, JobsAborted);
+    }
   }
 }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentListView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentListView.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentListView.cs	(revision 6033)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Windows.Forms;
 using HeuristicLab.Core;
@@ -27,6 +28,6 @@
 namespace HeuristicLab.Clients.Hive.Views {
   [View("HiveExperimentList View")]
-  [Content(typeof(ItemCollection<HiveExperiment>), false)]
-  public partial class HiveExperimentListView : ItemCollectionView<HiveExperiment> {
+  [Content(typeof(ItemCollection<RefreshableHiveExperiment>), false)]
+  public partial class HiveExperimentListView : ItemCollectionView<RefreshableHiveExperiment> {
 
     public HiveExperimentListView() {
@@ -34,6 +35,13 @@
     }
 
-    protected override HiveExperiment CreateItem() {
-      return new HiveExperiment();
+    protected override RefreshableHiveExperiment CreateItem() {
+      return new RefreshableHiveExperiment();
+    }
+
+    protected override void removeButton_Click(object sender, EventArgs e) {
+      DialogResult result = MessageBox.Show("This action will permanently delete this experiment (also on the hive server). Continue?", "Delete Experiment", MessageBoxButtons.OKCancel);
+      if (result == DialogResult.OK) {
+        base.removeButton_Click(sender, e);
+      }
     }
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentManagerView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentManagerView.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentManagerView.cs	(revision 6033)
@@ -21,5 +21,7 @@
 
 using System;
+using System.Linq;
 using System.Windows.Forms;
+using HeuristicLab.Collections;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
@@ -50,4 +52,6 @@
       Content.Refreshing += new EventHandler(Content_Refreshing);
       Content.Refreshed += new EventHandler(Content_Refreshed);
+      Content.HiveExperimentsChanged += new EventHandler(Content_HiveExperimentsChanged);
+      
     }
 
@@ -55,4 +59,5 @@
       Content.Refreshing -= new EventHandler(Content_Refreshing);
       Content.Refreshed -= new EventHandler(Content_Refreshed);
+      Content.HiveExperimentsChanged -= new EventHandler(Content_HiveExperimentsChanged);
       base.DeregisterContentEvents();
     }
@@ -101,6 +106,6 @@
     protected override void OnClosing(FormClosingEventArgs e) {
       base.OnClosing(e);
-      if (Content != null) {
-        foreach (var exp in Content.HiveExperiments) {
+      if (Content != null && Content.HiveExperiments != null) {
+        foreach (var exp in Content.HiveExperiments.OfType<RefreshableHiveExperiment>()) {
           if (exp.RefreshAutomatically) {
             exp.RefreshAutomatically = false; // stop result polling
@@ -109,4 +114,14 @@
       }
     }
+
+    private void HiveExperiments_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<RefreshableHiveExperiment> e) {
+      foreach (var item in e.Items) {
+        ExperimentManagerClient.Delete(item);
+      }
+    }
+
+    private void Content_HiveExperimentsChanged(object sender, EventArgs e) {
+      Content.HiveExperiments.ItemsRemoved += new CollectionItemsChangedEventHandler<RefreshableHiveExperiment>(HiveExperiments_ItemsRemoved);
+    }
   }
 }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs	(revision 6033)
@@ -29,4 +29,5 @@
   [View("HiveJob View")]
   [Content(typeof(HiveJob), true)]
+  [Content(typeof(HiveJob<>), false)]
   public partial class HiveJobView : ItemView {
     public new HiveJob Content {
@@ -45,5 +46,5 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.OptimizerJobChanged += new EventHandler(Content_OptimizerJobChanged);
+      Content.JobItemChanged += new EventHandler(Content_JobItemChanged);
       Content.JobChanged += new EventHandler(Content_JobChanged);
       Content.JobStateChanged += new EventHandler(Content_JobStateChanged);
@@ -51,5 +52,5 @@
 
     protected override void DeregisterContentEvents() {
-      Content.OptimizerJobChanged -= new EventHandler(Content_OptimizerJobChanged);
+      Content.JobItemChanged -= new EventHandler(Content_JobItemChanged);
       Content.JobChanged -= new EventHandler(Content_JobChanged);
       Content.JobStateChanged -= new EventHandler(Content_JobStateChanged);
@@ -60,46 +61,29 @@
       base.OnContentChanged();
       if (Content != null && Content.Job != null) {
-        logView.Content = Content.OptimizerJob.Log;
-        computeInParallelCheckBox.Checked = Content.OptimizerJob.ComputeInParallel;
+        computeInParallelCheckBox.Checked = Content.JobItem.ComputeInParallel;
       } else {
-        logView.Content = null;
         computeInParallelCheckBox.Checked = false;
       }
-      Content_OptimizerJobChanged(this, EventArgs.Empty);
+      Content_JobItemChanged(this, EventArgs.Empty);
       Content_JobChanged(this, EventArgs.Empty);
       Content_JobStateChanged(this, EventArgs.Empty);
     }
 
-    protected void Content_OptimizerJobChanged(object sender, EventArgs e) {
-      RegisterJobEvents();
-      Job_OptimizerChanged(this, e);
-    }
-
-    protected void Job_OptimizerChanged(object sender, EventArgs e) {
-      if (Content != null && Content.Job != null && Content.OptimizerJob.Optimizer != null) {
-        optimizerNamedItemView.Content = Content.OptimizerJob.Optimizer;
-        runCollectionViewHost.Content = Content.OptimizerJob.Optimizer.Runs;
-      } else {
-        optimizerNamedItemView.Content = null;
-        runCollectionViewHost.Content = null;
+    protected virtual void RegisterJobEvents() {
+      if (Content != null && Content.Job != null) {
+        Content.JobItem.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
+        Content.JobItem.ItemChanged += new EventHandler(Job_ItemChanged);
       }
     }
 
-    private void RegisterJobEvents() {
+    protected virtual void DeregisterJobEvents() {
       if (Content != null && Content.Job != null) {
-        Content.OptimizerJob.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        Content.OptimizerJob.OptimizerChanged += new EventHandler(Job_OptimizerChanged);
-      }
-    }
-
-    private void DeregisterJobEvents() {
-      if (Content != null && Content.Job != null) {
-        Content.OptimizerJob.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        Content.OptimizerJob.OptimizerChanged -= new EventHandler(Job_OptimizerChanged);
+        Content.JobItem.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
+        Content.JobItem.ItemChanged -= new EventHandler(Job_ItemChanged);
       }
     }
 
     #region Content Events
-    private void Content_JobChanged(object sender, EventArgs e) {
+    protected virtual void Content_JobChanged(object sender, EventArgs e) {
       if (InvokeRequired) {
         Invoke(new EventHandler(Content_JobChanged), sender, e);
@@ -121,5 +105,18 @@
     }
 
-    private void Content_JobStateChanged(object sender, EventArgs e) {
+    protected virtual void Content_JobItemChanged(object sender, EventArgs e) {
+      RegisterJobEvents();
+      Job_ItemChanged(this, e);
+    }
+
+    protected virtual void Job_ItemChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Job != null && Content.JobItem.Item != null) {
+        optimizerItemView.Content = Content.JobItem.Item;
+      } else {
+        optimizerItemView.Content = null;
+      }
+    }
+
+    protected virtual void Content_JobStateChanged(object sender, EventArgs e) {
       if (InvokeRequired) {
         Invoke(new EventHandler(Content_JobStateChanged), sender, e);
@@ -131,5 +128,5 @@
           this.exceptionTextBox.Text = Content.Job.CurrentStateLog != null ? Content.Job.CurrentStateLog.Exception : string.Empty;
           this.lastUpdatedTextBox.Text = Content.Job.LastJobDataUpdate.ToString();
-          if (Content.OptimizerJob.ComputeInParallel) {
+          if (Content.JobItem.ComputeInParallel) {
             this.stateLogViewHost.Content = new StateLogListList(
                 this.Content.ChildHiveJobs.Select(child => new StateLogList(child.Job.StateLog)
@@ -165,30 +162,28 @@
       this.coresNeededTextBox.ReadOnly = this.ReadOnly;
       this.memoryNeededTextBox.ReadOnly = this.ReadOnly;
-      this.computeInParallelCheckBox.Enabled = !this.ReadOnly && this.Content != null && this.Content.OptimizerJob != null && this.Content.OptimizerJob.IsParallelizable;
+      this.computeInParallelCheckBox.Enabled = !this.ReadOnly && this.Content != null && this.Content.JobItem != null && this.Content.JobItem.IsParallelizable;
 
-      this.restartButton.Enabled = Content != null && Content.Job.State == JobState.Paused;
-      this.pauseButton.Enabled = Content != null && Content.Job.State == JobState.Calculating;
-      this.stopButton.Enabled = Content != null && (Content.Job.State == JobState.Calculating || Content.Job.State == JobState.Waiting || Content.Job.State == JobState.Paused);
-      this.showOptimizerButton.Enabled = Content != null && Content.Job.State == JobState.Paused && Content.OptimizerJob != null && Content.OptimizerJob.Optimizer != null;
+      this.modifyItemButton.Enabled = (Content != null && Content.JobItem.Item != null && (Content.Job.State == JobState.Paused || Content.Job.State == JobState.Offline || Content.Job.State == JobState.Finished || Content.Job.State == JobState.Failed || Content.Job.State == JobState.Aborted));
 
-      optimizerNamedItemView.ReadOnly = true;
+      optimizerItemView.ReadOnly = true;
     }
 
-    void OptimizerJob_ComputeInParallelChanged(object sender, EventArgs e) {
+    protected virtual void OptimizerJob_ComputeInParallelChanged(object sender, EventArgs e) {
       if (InvokeRequired) {
         Invoke(new EventHandler(OptimizerJob_ComputeInParallelChanged), sender, e);
       } else {
-        computeInParallelCheckBox.Checked = Content.OptimizerJob.ComputeInParallel;
+        computeInParallelCheckBox.Checked = Content.JobItem.ComputeInParallel;
       }
     }
     #endregion
 
-    private void computeInParallelCheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (Content != null && Content.OptimizerJob != null) {
-        this.Content.OptimizerJob.ComputeInParallel = this.computeInParallelCheckBox.Checked;
+    #region Child Control Events
+     protected virtual void computeInParallelCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (Content != null && Content.JobItem != null) {
+        this.Content.JobItem.ComputeInParallel = this.computeInParallelCheckBox.Checked;
       }
     }
 
-    private void exceptionTextBox_DoubleClick(object sender, EventArgs e) {
+    protected virtual void exceptionTextBox_DoubleClick(object sender, EventArgs e) {
       using (TextDialog dialog = new TextDialog("Exception", exceptionTextBox.Text, ReadOnly || !Content.CanChangeDescription)) {
         if (dialog.ShowDialog(this) == DialogResult.OK)
@@ -197,18 +192,8 @@
     }
 
-    private void restartButton_Click(object sender, EventArgs e) {
-      Content.Restart();
+    protected virtual void modifyItemButton_Click(object sender, EventArgs e) {
+      MainFormManager.MainForm.ShowContent(Content.JobItem.Item);
     }
-
-    private void pauseButton_Click(object sender, EventArgs e) {
-      Content.Pause();
-    }
-
-    private void stopButton_Click(object sender, EventArgs e) {
-      Content.Stop();
-    }
-    private void showOptimizerButton_Click(object sender, EventArgs e) {
-      MainFormManager.MainForm.ShowContent(Content.OptimizerJob.Optimizer);
-    }
+    #endregion
   }
 }
